/* ccgo: sgf_go_node.hh
 * 
 * Copyright 2002 Chun-Chung Chen <cjj@u.washington.edu>
 * 
 * This program is free software; you can redistribute it and'or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 * 
 * This class is used to convert the topology of the SGF tree to what's use by ccgo.
 */

#ifndef SGF_GO_NODE_HH
#define SGF_GO_NODE_HH
#include "../node.hh"
#include "../root_proper.hh"
#include "../modifi_proper.hh"
#include "../game.hh"
#include "tree.hh"
namespace sgf {
	class GoNode :
		virtual public go::Node,
		virtual public Node
	{

		go::Node * sub_game_tree(go::Game &) const;
	public:
		GoNode(const sgf::Node &);
		GoNode(const Tree &);
		virtual ~GoNode();

		// a GoNode can be used to setup propers
		void setup(go::Proper &, unsigned z) const;
		void setup(go::RootProper &) const;
		void setup(go::ModifiProper &, const go::Game &) const;

		go::Node * get_game_tree() const;
	};
}
#endif // GO_NODE_HH
